/******************************************************
* bitrate.c - Bitrate Calculator                      *
* GPLed - Stephan T. Lavavej - http://stl.caltech.edu *
******************************************************/
#define VERSION "v1.0"

#include <stdio.h>
#include <stdlib.h>
#define AUDIO_BITRATE 128

int main(int argc, char *argv[]) {
    int hours, minutes, seconds, megs, videokbps;

    printf("Bitrate Calculator " VERSION " [GPLed] by Stephan T. Lavavej, http://stl.caltech.edu" "\n");

    if (argc < 4 || argc > 5) {
        printf("GPL:   http://www.gnu.org/licenses/gpl.txt" "\n");
        printf("USAGE: bitrate [hours] minutes seconds megabytes\n");
        exit(EXIT_SUCCESS);
    }

    hours   = (argc == 4) ? 0 : atoi(argv[1]);
    minutes = atoi(argv[argc - 3]);
    seconds = atoi(argv[argc - 2]);
    megs    = atoi(argv[argc - 1]);

    if (hours < 0 || minutes < 0 || seconds < 0 || megs < 1 || minutes > 59 || seconds > 59) {
        printf("ERROR: Invalid parameter.\n");
        exit(EXIT_FAILURE);
    }

    videokbps = (megs * 8192) / (hours * 3600 + minutes * 60 + seconds) - AUDIO_BITRATE;

    if (videokbps <= 0) {
        printf("ERROR: Insufficient file size specified.\n");
        exit(EXIT_FAILURE);
    } else {
        printf("Video bitrate: %d kbps\n", videokbps);
        printf("Audio bitrate: %d kbps\n", AUDIO_BITRATE);
        exit(EXIT_SUCCESS);
    }
}

/***************************
* Version History:         *
* v1.0 - Initial C version *
***************************/
